#include <cstdlib>
#include <iostream>
#include <fstream>
#include "Trie.hpp"

bool is_word(const std::string& word) {
   for (char ch: word) {
      if (!((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'))) {
	 return false;
      }
   }
   return true;
}

void visit(const std::string& word) {
   std::cout << word << std::endl;
}

int main() {
   Trie<std::string> trie;
   std::ifstream words("/usr/dict/words");
   if (!words) {
      std::cout << "unable to open /usr/dict/words. Bye" << std::endl;
      std::exit(1);
   }
   std::string line;
   while (std::getline(words, line)) {
      if (is_word(line)) {
	 trie.insert(line, line);
      }
   }
   std::string key;
   while (std::cin >> key) {
      if (is_word(key)) {
	 trie.visit(key, visit);
      }
   }
}
